#ifndef _CELL_H_
#define _CELL_H_

//cell max
#define CELL_MAX       (1024 * 10)

#define CELL_WORK_MAX  (128)

//cell object
struct cell {
  enum {
    gc = 0x80000000,
  };
  unsigned long mark;
  cell *first;
  cell *rest;
  
  void (*update)(cell *);
  void (*render)(cell *);
  
  //to do write special
  int   id;
  int   count;
  float x, y, dx, dy;
  
  //work
  char work[CELL_WORK_MAX];
};

void init_cell();


int is_nil_cell(cell *t);
int is_gc_cell(cell *t);

inline cell *set_id_cell(cell *t, int id) {
  if(t) {
    t->id = id;
  }
  return t;
}

inline int get_id_cell(cell *t) {
  if(t) {
    return t->id;
  }
  return 0;
}

cell *nil_cell();
cell *add_cell( void (*update)(cell *), void (*render)(cell *) );
int do_update_cell();
int do_render_cell();
cell *do_gc_cell();
cell *mark_gc_cell(cell *t);

int count_cell();

//ċA
int do_update_cell_r();

#endif
