#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "misc.h"

#ifdef D3DXToRadian
#define RAD(x) D3DXToRadian(x)
#else
#define RAD(x) (3.14159265358979f * x / 180.0f)
#endif

//sin table
static float angle_table[ANGLE_MAX];

//initialize angle
static void init_angle() {
  for(int i = 0 ; i < ANGLE_MAX; i++) {
    float d = 360.0f / (float)ANGLE_MAX;
    angle_table[i] = sin( RAD(d * i) );
  }
}

void init_misc() {
  init_angle();
}

float get_sin(int i) {
  return angle_table[ i & ANGLE_MASK ];
}

float get_cos(int i) {
  return angle_table[ (i + (ANGLE_MAX >> 1)) & ANGLE_MASK ];
}

float get_len(point p) {
  return sqrt(p.x * p.x + p.y * p.y);
}

void set_point_power(point &p, float power) {
  float len = get_len(p);
  if(len != 0.0f) {
    p.x = (p.x / len) * power;
    p.y = (p.y / len) * power;
  }
}

void set_point_angle(point &dest, point &p1, point &p2, float speed) {
  float x = p2.x - p1.x;
  float y = p2.y - p1.y;
  dest.x = x;
  dest.y = y;
  set_point_power(dest, speed);
}


